/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef CONTAINERP_H
#define CONTAINERP_H

typedef struct {
	XtPointer	extension;
} ContainerClassPart;

typedef struct _ContainerClassRec {
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	ContainerClassPart	container_class;
} ContainerClassRec, *ContainerWidgetClass;

extern ContainerClassRec containerClassRec;

typedef struct {
	GC		top_GC;
	GC		bot_GC;
	Cursor	cursor;
	Pixel	top_pixel;
	Pixel	bot_pixel;
	Pixel	foreground;
	int		shadow_thickness;
	XtPointer user_data;
} ContainerPart;

typedef struct _ContainerRec {
	CorePart		core;
	CompositePart	composite;
	ConstraintPart	constraint;
	ContainerPart	container;
} ContainerRec, *ContainerWidget;

#ifndef EXTERNAL_FUNC
#define EXTERNAL_FUNC
extern void _DrawShadow (Display*, Drawable, GC, GC, int, int, int, int, int);
extern void _GetTopShadowColor (Widget, int, XrmValue*);
extern void _GetBottomShadowColor (Widget, int, XrmValue*);

#endif
#endif
