/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#define XtRStringArray "StringArray"

typedef struct {
	XtPointer	extension;
} DialogClassPart;

typedef struct _DialogClassRec {
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	ContainerClassPart	manager_class;
	DialogClassPart	dialog_class;
} DialogClassRec;

extern DialogClassRec	dialogClassRec;

typedef struct {
	Widget	ok_button;
	Widget	cancel_button;
	Widget	apply_button;

	Widget	active;
	Boolean	auto_ok;

	Widget*	toggle_widgets;
	int		num_toggle;
	int		def_toggle;
	int		def_button;
	Widget*	label_widgets;
	Widget*	edit_widgets;
	int		num_fields;

	int		title_height;
	int		title_width;
	int		max_toggle;
	int		max_label;

	String	title;
	String	ok_label;
	String	cancel_label;
	String	apply_label;
	String*	toggle;
	String*	fields;
	XtCallbackList	ok_callback;
	XtCallbackList	apply_callback;
	XtCallbackList	cancel_callback;
} DialogPart;

typedef struct _DialogRec {
	CorePart	core;
	CompositePart   composite;
	ConstraintPart	constraint;
	ContainerPart	manager;
	DialogPart	dialog;
} DialogRec;

#define DEFAULT_HEIGHT 300
#define DEFAULT_WIDTH 30

#define	C	w -> core
#define M	w -> manager
#define	W	w -> dialog
#define OK	w -> dialog.ok_button
#define CAN	w -> dialog.cancel_button
#define APPLY	w -> dialog.apply_button
