/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef	EDITORW_H
#define	EDITORW_H

extern WidgetClass editorWidgetClass;

enum Scenery {
	SceneryBottom, SceneryTop, NoScenery
};


// Fonctions Globales.

Widget	XpaCreateEditor (Widget, char*, ArgList, Cardinal);
Widget	XpaCreateScrolledEditor (Widget, char*, ArgList, Cardinal);
Boolean EditorLoadFile (Widget widget, char* name);
Boolean EditorSaveFile (Widget widget, char* name);

//
//	La table des clefs.
//

struct KeyTable {
	KeyTable*		prefix;	// prfixe??  0 => non, sinon @ table
	XtActionProc	proc;	// l'action associe
	char*			arg;	// son eventuel argument 
};

KeyTable* EditorStringToKeyTable (char* str);
KeyTable* EditorCopyKeyTable (KeyTable* tt);
KeyTable* EditorOverrideKeyTable (KeyTable* tt, char* str);

#define	K_UP		128
#define	K_DOWN		129
#define	K_LEFT		130
#define	K_RIGHT		131
#define	K_NUMBER	(K_RIGHT+1)	// nombre total de codes utiliss

struct ScrollbarCallbackStruct {
	int	numline;
	int	topline;
	int	winline;
};

#ifndef XtNkeyTable
#define XtNkeyTable	"keyTable"
#define XtCKeyTable	"KeyTable"
#define XtRKeyTable	"KeyTable"
#endif

#ifndef XtNuserData
#define	XtNuserData	"userData"
#endif

#ifndef XtCUserData
#define	XtCUserData	"UserData"
#endif

#ifndef	XtCCursorColor
#define	XtCCursorColor	"CursorColor"
#endif

#ifndef	XtCShowLineNumber
#define	XtCShowLineNumber	"ShowLineNumber"
#endif

#ifndef	XtNshowLineNumber
#define	XtNshowLineNumber	"showLineNumber"
#endif

#ifndef XtNsceneryType
#define	XtNsceneryType	"sceneryType"
#define XtCSceneryType	"SceneryType"
#endif

#ifndef	XtNsceneryColor
#define	XtNsceneryColor	"sceneryColor"
#endif

#ifndef	XtNcursorColor
#define	XtNcursorColor	"cursorColor"
#endif

#ifndef	XtNcursorTabColor
#define	XtNcursorTabColor	"cursorTabColor"
#endif

#ifndef	XtNcursor
#define	XtNcursor	"cursor"
#endif

#ifndef	XtNbusyCursor
#define	XtNbusyCursor	"busyCursor"
#endif

#ifndef	XtNdragCursor
#define	XtNdragCursor	"dragCursor"
#endif

#ifndef	XtNhorizontalMotionCursor
#define	XtNhorizontalMotionCursor		"horizontalMotionCursor"
#endif

#ifndef	XtNverticalMotionCursor
#define	XtNverticalMotionCursor		"verticalMotionCursor"
#endif

#ifndef	XtCSelectionColor
#define	XtCSelectionColor	"SelectionColor"
#endif

#ifndef	XtNprimarySelectionColor
#define	XtNprimarySelectionColor	"primarySelectionColor"
#endif

#ifndef	XtNsecondarySelectionColor
#define	XtNsecondarySelectionColor	"secondarySelectionColor"
#endif

#ifndef	XtNcolor2
#define	XtNcolor2	"color2"
#endif

#ifndef	XtNcolor3
#define	XtNcolor3	"color3"
#endif

#ifndef	XtNcolor4
#define	XtNcolor4	"color4"
#endif

#ifndef	XtNcolor5
#define	XtNcolor5	"color5"
#endif

#ifndef	XtNcolor6
#define	XtNcolor6	"color6"
#endif

#ifndef	XtNcolor7
#define	XtNcolor7	"color7"
#endif

#ifndef	XtNcolor8
#define	XtNcolor8	"color8"
#endif

#ifndef	XtNcolor9
#define	XtNcolor9	"color9"
#endif

#ifndef	XtNverticalScrollbarCallback
#define	XtNverticalScrollbarCallback	"verticalScrollbarCallback"
#endif

#ifndef	XtNhorizontalScrollbarCallback
#define	XtNhorizontalScrollbarCallback	"horizontalScrollbarCallback"
#endif

#ifndef	XtNfontCallback
#define	XtNfontCallback		"fontCallback"
#endif

#endif
