/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef FSELECTOR_H
#define FSELECTOR_H

#include <Xpa/Icon.h>
#include <Xpa/abspath.h>

extern WidgetClass fileSelectorWidgetClass;

typedef struct _FileSelectorClassRec*	FileSelectorWidgetClass;
typedef struct _FileSelectorRec*		FileSelectorWidget;

extern _CPP_ void	PopFileSelector (Widget, char*, char*, char*, Boolean);
extern _CPP_ Widget	FileSelectorGetChild (Widget, int);
extern _CPP_ void	FileSelectorSmallIcon (Widget, Boolean);
extern _CPP_ void	FileSelectorTypeSort (Widget, Boolean);
extern _CPP_ void	FileSelectorUpdate (Widget, String);

typedef struct {
	char	from [256];
	char	to [256];
	Ipix	ip_from;
	Ipix	ip_to;
	Widget	dest_fmgr;
	Widget	target;
} FSDropCallbackStruct;

typedef struct {
	char*	old_name;
	char*	new_name;
	Boolean	doit;
} FSRenameCallbackStruct;

#define FS_OK		0
#define FS_CANCEL	1
#define FS_FILTER	2
#define FS_EXPAND	3
#define FS_FSPEC	4
#define FS_ICON		5

#define	XtNtexPixmap	"texPixmap"
#define	XtNdviPixmap	"dviPixmap"
#define	XtNpsPixmap		"psPixmap"
#define	XtNbmPixmap		"bmPixmap"
#define	XtNccPixmap		"ccPixmap"
#define	XtNoPixmap		"oPixmap"
#define	XtNhPixmap		"hPixmap"
#define	XtNcPixmap		"cPixmap"
#define	XtNzPixmap		"zPixmap"
#define	XtNaPixmap		"aPixmap"
#define	XtNexecPixmap	"execPixmap"
#define	XtNfilePixmap		"filePixmap"
#define	XtNdirPixmap		"dirPixmap"
#define	XtNdotPixmap		"dotPixmap"
#define	XtNjavaPixmap		"javaPixmap"

#ifndef XtCIconPixmap
#define	XtCIconPixmap		"IconPixmap"
#endif

#ifndef XtNfilter
#define	XtNfilter	"filter"
#define	XtCFilter	"Filter"
#endif

#ifndef XtNtitle
#define	XtNtitle	"title"
#define	XtCTitle	"Title"
#endif

#ifndef XtNdirectory
#define	XtNdirectory	"directory"
#define	XtCDirectory	"Directory"
#endif

#ifndef XtNoffset
#define	XtNoffset	"offset"
#define	XtCOffset	"Offset"
#endif

#ifndef XtNdirOnly
#define	XtNdirOnly	"dirOnly"
#define	XtCDirOnly	"DirOnly"
#endif

#ifndef XtNnoObject
#define	XtNnoObject	"noObject"
#define	XtCNoObject	"NoObject"
#endif

#ifndef XtNnoEdit
#define	XtNnoEdit	"noEdit"
#define	XtCNoEdit	"NoEdit"
#endif

#ifndef XtNnoDotfile
#define	XtNnoDotfile	"noDotfile"
#define	XtCNoDotfile	"NoDotfile"
#endif

#ifndef XtNokCallback
#define	XtNokCallback	"okCallback"
#endif

#ifndef XtNcancelCallback
#define	XtNcancelCallback	"cancelCallback"
#endif

#ifndef XtNdropCallback
#define	XtNdropCallback		"dropCallback"
#endif

#ifndef XtNrenameCallback
#define	XtNrenameCallback	"renameCallback"
#endif

#endif
