/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#define	F_DIRECTORY		0
#define	F_DOTFILE		1
#define	F_CTEXT			2
#define	F_CPLUSPLUS		3
#define	F_PLAINFILE		4
#define	F_HEADER		5
#define	F_EXECUTABLE	6
#define	F_ARCHIVE		7
#define	F_COMPRESSED	8
#define	F_OBJECT		9
#define	F_BITMAP		10
#define	F_DVI			11
#define	F_TEX			12
#define	F_POSTSCRIPT	13
#define	F_JAVA			14

#define	N_PIXMAP		15

typedef struct {
	XtPointer	extension;
} FileSelectorClassPart;

typedef struct _FileSelectorClassRec {
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	ContainerClassPart	manager_class;
	FileSelectorClassPart	fileSelector_class;
} FileSelectorClassRec;

extern FileSelectorClassRec	fileSelectorClassRec;

typedef struct {
	Widget		clip;
	Widget		fs_icon;
	Widget		fs_wix;
	Widget		ok_button;
	Widget		expand_button;
	Widget		cancel_button;
	Widget		filter_button;
	Widget		edit;
	String		title;
	String		filter;
	int		sep_y;
	String		directory;
	XtCallbackList	ok_callback;
	XtCallbackList	cancel_callback;
	XtCallbackList	drop_callback;
	XtCallbackList	rename_callback;
	int		offset;
	Boolean		dir_only;
	Boolean		no_object;
	Boolean		no_dotfile;
	Boolean		no_edit;
	Boolean		sort;
	Pixmap		pixmap [N_PIXMAP];
	Pixmap		small_pixmap [N_PIXMAP];
} FileSelectorPart;

typedef struct _FileSelectorRec {
	CorePart		core;
	CompositePart   	composite;
	ConstraintPart		constraint;
	ContainerPart		manager;
	FileSelectorPart	fileSelector;
} FileSelectorRec;
