/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef FRAMEP_H
#define FRAMEP_H

typedef struct {
	XtPointer	extension;
} FrameClassPart;

typedef struct {
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	FrameClassPart		frame_class;
} FrameClassRec;

extern FrameClassRec frameClassRec;

#define MAX_SIZE	20

typedef struct {
	char*			title;
	GC				gc;
	Pixel			foreground;
	Pixel			hilite;
	Boolean			focused;
	XFontStruct*	font;
	Cursor			cursor;
	Cursor			motion_cursor;
	XtPointer		user_data;
	int				border_size;
	Pixel			pixels [MAX_SIZE];
	int				npixels;
	XtCallbackList	close_callback;
	XtCallbackList	max_callback;
	XtCallbackList	min_callback;
} FramePart;

typedef struct {
	CorePart		core;
	CompositePart	composite;
	FramePart		frame;
} FrameRec, *FrameWidget;

#endif
