/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef ICON_H
#define ICON_H
/*
 *	Les icones
 */

typedef struct _Ipix {
	struct _Ipix*	next;	/* les icones sont chaines */
	String	label;		/* texte de l'ipix */
	Pixmap	pixmap;		/* pixmap normal */
	short	p_width;	/* largeur du pixmap */
	short	p_height;	/* hauteur du pixmap */
	short	p_depth;	/* sa profondeur (bitmap ou pas) */
	short	x, y;		/* position de l'ipix */
	short	width, height;	/* dimension de l'ipix */
	short	rank;		/* le critere de tri */
	Boolean	selected;	/* ipix selecte */
	struct _Ipix*	next_selected;	/* les icones selectes sont aussi chaines */
	Boolean	sensible;	/* sensible au drag */
} IpixRec, *Ipix;

typedef struct {
	Widget	target;
	Widget	shell;
	Ipix	source;
	Ipix	dest;
} DropCallbackStruct;

/*
 *	Les fonctions exportes
 */

extern _CPP_ void		IconAlign (Widget, Boolean, Boolean);
extern _CPP_ void		IcRedraw (Widget);
extern _CPP_ Ipix		IcCreateIpix (Widget, char*, Pixmap, short, Boolean);
extern _CPP_ Boolean	IcDestroyIpix (Widget, Ipix, Boolean);
extern _CPP_ void		IcDestroyAllIpix (Widget);
extern _CPP_ Ipix		IcGetIconList (Widget);
extern _CPP_ void		IcSelectIpix (Widget, Ipix, Boolean);

extern WidgetClass iconWidgetClass;

typedef struct _IconClassRec *IconWidgetClass;
typedef struct _IconRec      *IconWidget;

#ifndef XtNhotColor
#define XtNhotColor	"hotColor"
#endif

#ifndef XtNgridWidth
#define XtNgridWidth	"gridWidth"
#endif

#ifndef XtNgridHeight
#define XtNgridHeight	"gridHeight"
#endif

#ifndef XtNdblClickCallback
#define XtNdblClickCallback	"dblClickCallback"
#endif

#ifndef XtNdropCallback
#define XtNdropCallback	"dropCallback"
#endif

#ifndef XtNeditCallback
#define XtNeditCallback	"editCallback"
#endif

#ifndef XtNinvertOnSelect
#define XtNinvertOnSelect	"invertOnSelect"
#endif

#ifndef XtNmotionCursor
#define	XtNmotionCursor	"motionCursor"
#endif

#ifndef XtNcursor
#define	XtNcursor	"cursor"
#endif

#ifndef XtNwaitCursor
#define	XtNwaitCursor	"waitCursor"
#endif

#ifndef XtNsortFunction
#define XtNsortFunction	"sortFunction"
#endif

#ifndef XtNsmallIcons
#define	XtNsmallIcons	"smallIcons"
#define XtCSmallIcons	"SmallIcons"
#endif

#ifndef XtNnoDrag
#define	XtNnoDrag	"noDrag"
#define XtCNoDrag	"NoDrag"
#endif

#endif
