/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

/*
 *	La fenetre d'icones.
 */

typedef int (*CompareFunction) (Ipix*, Ipix*);

typedef struct _IconPart {
	XFontStruct*	fp;
	Cursor			motion_cursor;
	Cursor			wait_cursor;
	int				margin;
	int				grid_width;
	int				grid_height;
	GC				label_GC;
	GC				inverse_GC;
	Pixel			hot_color;
	Boolean			small;
	Boolean			noDrag;
	CompareFunction	sort_function;
	XtCallbackList	dbl_click_callback;
	XtCallbackList	drop_callback;
	XtCallbackList	edit_callback;
	Ipix			selected;
	Ipix			ipix;
	Ipix			last;
	Ipix			free;
} IconPart;

typedef struct _IconRec {
	CorePart		core;
	PrimitivePart	primitive;
	IconPart		icon;
} IconRec;

/*
 *	Class record.
 */

typedef struct {
	int	rien;
} IconClassPart;

typedef struct _IconClassRec {
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
	IconClassPart		icon_class;
} IconClassRec;

extern IconClassRec iconClassRec;
