/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef MENUBAR_H
#define MENUBAR_H

extern WidgetClass menuBarWidgetClass;

typedef struct _MenuBarClassRec *MenuBarWidgetClass;
typedef struct _MenuBarRec      *MenuBarWidget;

/*
 *	Modes de dialogue pour la boite d'experts.
 */

typedef enum {
	DM_FileSelectionRead,
	DM_FileSelectionCreate,
	DM_GetString,
	DM_GetStringIncremental
} DialogMode;

extern _CPP_ void PopMenubarDialog (Widget mb, Widget active, char* label,
									DialogMode mode, char* reponse);
extern _CPP_ void SetAutoExpand (Widget, void (*)(Widget, XtPointer));
extern _CPP_ void SetConfirmAction (Widget, void (*)(Widget, char*));
extern _CPP_ void SetDefaultAction (Widget, void (*)(Widget, XtPointer));
extern _CPP_ void DestroyFSWindow (Widget);

#ifndef XtNfilter
#define XtNfilter	"filter"
#define XtCFilter	"Filter"
#endif

#ifndef XtNsuffixes
#define XtNsuffixes	"suffixes"
#define XtCSuffixes	"Suffixes"
#endif

#ifndef XtNhidden
#define XtNhidden	"hidden"
#define XtCHidden	"Hidden"
#endif

#ifndef XtRMenuBar
#define	XtRMenuBar	"MenuBar"
#endif

#ifndef XtNarmColor
#define XtNarmColor	"armColor"
#define XtCArmColor	"ArmColor"
#endif

#ifndef XtNcursor
#define XtNcursor	"cursor"
#define XtCCursor	"Cursor"
#endif

#ifndef XtNacceleratorColor
#define XtNacceleratorColor "acceleratorColor"
#endif

#ifndef XtNoblong
#define XtNoblong	"oblong"
#define XtCOblong	"Oblong"
#endif

#ifndef XtNmnemonicOn
#	define XtNmnemonicOn	"mnemonicOn"
#	define XtCMnemonicOn	"MnemonicOn"
#endif

#ifndef XtNmargin
#	define XtNmargin	"margin"
#endif

#ifndef XtCMargin
#	define XtCMargin	"Margin"
#endif

#ifndef XtNhelp
#	define XtNhelp		"help"
#	define XtCHelp		"Help"
#endif

#ifndef XtNitem
#define		XtNreloadItem	"reloadItem"
#define		XtCReloadItem	"ReloadItem"
#define		XtNitem			"item"
#define		XtCItem			"Item"
#endif

#endif
