/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef MENUBARP_H
#define MENUBARP_H
/*
 *	La barre de menuBars.
 */

typedef struct {
	XtPointer	extension;
} MenuBarClassPart;

/*
 *	Class record.
 */

typedef struct _MenuBarClassRec {
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
	MenuBarClassPart	menuBar_class;
} MenuBarClassRec;

extern MenuBarClassRec menuBarClassRec;

typedef struct _MenuBarPart {
	XFontStruct*	font;
	int				font_height;
	GC				label_GC;
	GC				label_insensitive_GC;
	int				margin;
	Pixel			arm_color;
	Pixel			accelerator_color;
	Boolean			reload_item;
	Boolean			help;
	Boolean			oblong;
	Widget			thePopupShell;
	int*			m_acc_pos;
	int*			m_width;
	int*			m_height;
	int				m_selected;
	String**		item;
	char*			mnemonic;
	KeyCode*		mnemonic_kc;
	char*			mnemonic_pos;
	Boolean			mnemonic_on;
	int*			i_width;
	int				bar_height;
	int				num_item;
	int				selected;
	long			prev_pos;
	Cursor			cursor;
	/* tout pour la boite de dialogue */
	Boolean			hidden;			/* la barre de menu est elle masque? */
	char*			suffixes;		/* regexprs pour illuminer les noms */
	char*			filter;			/* regexpr pour filtrer les noms  afficher */
	Widget			active;			/* le widget qui avait le clavier */
	char			directory [256];/* le directory courant */
	char*			fs_answer;		/* la rponse */
	void	(*confirm_action) (Widget, char*);		/* validation finale */
	void	(*auto_expand) (Widget, XtPointer);		/* validation incrmentale */
	void	(*default_action) (Widget, XtPointer);	/* validation en cous de route */
	Widget			exp_row;		/* la boite des dialogues d'experts */
	Widget			exp_label;		/* le bouton de confirmation */
	Widget			exp_wix;		/* la zone de saisie de texte */
	Window			list_win;		/* la fentre pour afficher les noms des fichiers */
	int				min_clip_y;		/* position minimale */
	int				clip_y;			/* sa position par rapport  sa fentre de clipping */
	Window			clip_win;		/* la fentre qui la clippe */
	Boolean			locked;			/* verrou pour la verifyCallback */
	DialogMode		dialog_mode;	/* type d'utilisation de la boite */
} MenuBarPart;

typedef struct _MenuBarRec {
	CorePart		core;
	PrimitivePart	primitive;
	MenuBarPart		menuBar;
} MenuBarRec;

#endif
