/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef PANEDWINDOWP_H
#define PANEDWINDOWP_H

/* Constraint record (stored in the constraint field of each subwidget of th PanedWindow */

typedef struct _PanedWindowConstraintRec
{
	Boolean	resizable;
} PanedWindowConstraintRec, *PanedWindowConstraints;

typedef struct {
	XtPointer	extension;
} PanedWindowClassPart;

typedef struct _PanedWindowClassRec {
	CoreClassPart			core_class;
	CompositeClassPart		composite_class;
	ConstraintClassPart		constraint_class;
	ContainerClassPart		container_class;
	PanedWindowClassPart	panedWindow_class;
} PanedWindowClassRec, *PanedWindowWidgetClass;

extern PanedWindowClassRec panedWindowClassRec;

typedef struct {
	GC		sep_GC;
	int		sep_number;
	int*	sep_y;
	int		margin;
	int		padding;
	Widget*	managed_children;
	int		num_managed_children;
} PanedWindowPart;

typedef struct _PanedWindowRec {
	CorePart		core;
	CompositePart	composite;
	ConstraintPart	constraint;
	ContainerPart	container;
	PanedWindowPart	panedWindow;
} PanedWindowRec, *PanedWindowWidget;

#endif
