/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef PRIMITIVEP_H
#define PRIMITIVEP_H

typedef struct _PrimitivePart
{
	Pixel		foreground;
	Pixel		top_pixel;
	Pixel		bot_pixel;
	int			shadow_thickness;
	GC			top_GC;
	GC			bot_GC;
	Cursor		cursor;
	XtPointer	user_data;

	XtCallbackList select;
	XtCallbackList release;

	int				gravity;
	String			tip_message;
	XFontStruct*	tip_fp;
	Pixel			tip_background;
} PrimitivePart;

typedef struct _PrimitiveRec
{
	CorePart		core;
	PrimitivePart	primitive;
} PrimitiveRec, *PrimitiveWidget;

typedef struct _PrimitiveClassPart
{
	PrimitiveWidget	the_widget;
	Widget			tipWidget;
	GC				tipGC;
	XtIntervalId	tipTimer;
	XtPointer		extension;
} PrimitiveClassPart;

typedef struct _PrimitiveClassRec
{
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
} PrimitiveClassRec, *PrimitiveWidgetClass;

extern PrimitiveClassRec primitiveClassRec;

#ifndef EXTERNAL_FUNC
#define EXTERNAL_FUNC

extern void _DrawShadow (Display*, Drawable, GC, GC, int, int, int, int, int);
extern void _DrawOvalShadow (Display*, Drawable, GC, GC, int, int, int, int, int);
extern void _DrawDiamondShadow (Display*, Drawable, int, int, int, GC, GC, GC, Boolean);
extern void _EraseShadow (Display*, Drawable, int, int, int, int, int);
extern void _FillOvalShadow (Display*, Drawable, GC, int, int, int, int);
extern void DrawWindowShadow (Widget, Widget, XRectangle*, Boolean, int, int, int, int, int);


extern void _GetTopShadowColor (Widget, int, XrmValue*);
extern void _GetBottomShadowColor (Widget, int, XrmValue*);
extern void _GetArmColor (Widget, int, XrmValue*);

#endif
#endif
