/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

typedef struct {
	XtPointer	extension;
} PushButtonClassPart;

/*
 *	Class record.
 */

typedef struct _PushButtonClassRec {
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
	PushButtonClassPart	pushbutton_class;
} PushButtonClassRec;

extern PushButtonClassRec pushButtonClassRec;

typedef struct _PushButtonPart{
	String			label;
	Pixmap			pixmap;
	short			p_width;
	short			p_height;
	short			p_depth;
	short			margin;
	short			def_shadow;
	Boolean			invert_on_select;
	Boolean			set;
	Boolean			toggle;
	Boolean			oblong;
	GC				label_GC;
	XFontStruct*	fp;
	Pixel			arm_color;
#if 0
	String			tip_message;
	XFontStruct*	tip_fp;
	Pixel			tip_background;
#endif
#if 1
	Dimension		width;
	Dimension		height;
#endif
} PushButtonPart;

typedef struct _PushButtonRec {
	CorePart	core;
	PrimitivePart	primitive;
	PushButtonPart	pushbutton;
} PushButtonRec;
