/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

typedef struct {
	XtPointer	extension;
} QueryClassPart;

typedef struct _QueryClassRec {
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	ContainerClassPart	manager_class;
	QueryClassPart	query_class;
} QueryClassRec;

extern QueryClassRec	queryClassRec;

typedef struct {
	Widget		ok_button;
	Widget		cancel_button;
	Widget		apply_button;
	String		title;				/* le message */
	int			title_width;		/* sa largeur en pixels */
	int			title_nl;			/* nombre de lignes du message */
	String		ok_label;
	String		cancel_label;
	String		apply_label;
	String		label1;
	String		label2;
	String		label3;
	Widget		wix1;
	Widget		wix2;
	Widget		wix3;
	int			prompt;
	int			def_button;
	int			wix_offset;
	int			sep_y;
	XtCallbackList	ok_callback;
	XtCallbackList	apply_callback;
	XtCallbackList	cancel_callback;
	int			offset;
	Pixmap		pixmap;
	int			p_width, p_height;
	int			p_depth;
	int			height;
	Widget		work_area;
} QueryPart;

typedef struct _QueryRec {
	CorePart	core;
	CompositePart   composite;
	ConstraintPart	constraint;
	ContainerPart	manager;
	QueryPart	query;
} QueryRec;

#define DEFAULT_HEIGHT 30
#define DEFAULT_WIDTH 50

#define	C	w -> core
#define M	w -> manager
#define	W	w -> query
#define WORK	w -> query.work_area
#define WIX1	w -> query.wix1
#define WIX2	w -> query.wix2
#define WIX3	w -> query.wix3
#define OK		w -> query.ok_button
#define CAN		w -> query.cancel_button
#define APPLY	w -> query.apply_button
