/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

/*  Minimum slider width or height  */

#define MIN_SLIDER_SIZE	4

/*  Scrollbar class structure  */

typedef struct _ScrollbarClassPart
{
	XtPointer	extension;
} ScrollbarClassPart;


typedef struct _ScrollbarClassRec
{
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
	ScrollbarClassPart	scrollbar_class;
} ScrollbarClassRec;

extern ScrollbarClassRec scrollbarClassRec;


/*  The Scrollbar instance record  */

typedef struct _ScrollbarPart
{
	int		min;				/*  slider minimum coordiate position */
	int		max;				/*  slider maximum coordiate position */
	int		origin;				/*  slider edge location */
	int		extent;				/*  slider size */
	int		orientation;		/*  vertical or horizontal scrolling */
	Pixel	slider_color;
	GC		slider_GC;
	int		sliderX;
	int		sliderY;
	int		sliderWidth;
	int		sliderHeight;
	Boolean	armed;
	/* callback lists */
	XtCallbackList slider_moved;
	XtCallbackList area_selected;
} ScrollbarPart;


/*  Full instance record declaration  */

typedef struct _ScrollbarRec
{
	CorePart		core;
	PrimitivePart	primitive;
	ScrollbarPart	scrollbar;
} ScrollbarRec;

#define	C	w -> core
#define	P	w -> primitive
#define	W	w -> scrollbar
