/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

/*
 *	La liste verticale de chaines de caracteres.
 */

typedef struct {
	XtPointer	extension;
} TextListClassPart;

/*
 *	Class record.
 */

typedef struct {
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
	TextListClassPart	textList_class;
} TextListClassRec, *TextListWidgetClass;

extern TextListClassRec textListClassRec;

typedef struct _TextListPart {
	XFontStruct*	font;
	int				font_height;
	GC				label_GC;
	int				space;
	int				sb_size;
	int				sb_pos;
	XtCallbackList	vscroll_size;
	XtCallbackList	vscroll_pos;
	Boolean			force_size;
	Boolean			single_selection;
	int				selection_style;
	int				selection_number;
	String			selection;
	String*			items;
	int				num_items;
	int				num_lines;
	int				first_item;
	char*			selected;
	Pixel			selection_color;
} TextListPart;

typedef struct {
	CorePart		core;
	PrimitivePart	primitive;
	TextListPart	textList;
} TextListRec, *TextListWidget;
