/*****************************************************************

  Copyright (c) 1989 - 2009 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

/*  Minimum slider width or height  */

#define MIN_SLIDER_SIZE	4

/*  Valuator class structure  */

typedef struct _ValuatorClassPart
{
	XtPointer	extension;
} ValuatorClassPart;


typedef struct _ValuatorClassRec
{
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
	ValuatorClassPart	valuator_class;
} ValuatorClassRec;

extern ValuatorClassRec XwvaluatorClassRec;


/*  The Valuator instance record  */

typedef struct _ValuatorPart
{
	int		min;		  /*  slider minimum coordiate position */
	int		max;		  /*  slider maximum coordiate position */
	int		origin;		  /*  slider edge location */
	int		extent;		  /*  slider size */
	Pixel	slider_color;
	int		orientation;       /*  vertical or horizontal scrolling */
	XtCallbackList slider_moved;
	XtCallbackList slider_released;
	XtCallbackList area_selected;
	GC		slider_GC;
	int		sliderX;
	int		sliderY;
	int		sliderWidth;
	int		sliderHeight;
	Boolean	sliding_on;
	Boolean	armed;
} ValuatorPart;


/*  Full instance record declaration  */

typedef struct _ValuatorRec
{
   CorePart			core;
   PrimitivePart	primitive;
   ValuatorPart		valuator;
} ValuatorRec;

#define	C	w -> core
#define	P	w -> primitive
#define	W	w -> valuator
