#include <stdio.h>
#include <stdlib.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>

#if SYS_DIR
#	include <sys/dir.h>
#else
#	include <dirent.h>
#endif


/*
 *	Input name in nm, current directory
 *	in dir or in cur_dir if dir == NULL,
 *	absolute pathname returned.
 */

char* AbsPath (char* dir, char* nm)
{
	static char	cur_dir [256] =  { 0, };
	static char	buf [256];
	char*		s;
	char*		d;
	char		lnm [1024];

	if (dir == 0) {
		if (nm == 0) {
			/* rcuperer/initialiser le directory courant */
			if (cur_dir [0] == 0) {
				/* initialisation du directory courant */
				s = getenv ("HOME");
				if (s == 0)
					s = ".";
				strcpy (cur_dir, s);
			}
			return cur_dir;
		}
		dir = cur_dir;
	}
	strcpy (lnm, nm);
	d = buf;
	s = dir;
	nm = lnm;
	if (nm[0] == '~')		/* prefix ~ */
		if (nm[1] == '/' || nm[1] == 0)/* ~/filename */
			if ((s = (char *) getenv ("HOME")) != 0) {
				if (*++nm)
					nm++;
			}
			else
				s = "";
		else {			/* ~user/filename */
			char*			nnm;
			struct passwd*	pw;

			for (s = nm; *s && *s != '/'; s++);
			nnm = *s ? s + 1 : s;
			*s = 0;
			pw = (struct passwd *) getpwnam (nm + 1);
			if (pw == 0) {
				s = "";
			}
			else {
				nm = nnm;
				s = pw -> pw_dir;
			}
		}
	while ((*d++ = *s++) != 0);
	*(d - 1) = '/';
	s = nm;
	if (*s == '/' || *s == '[')
		d = buf;
	while ((*d++ = *s++) != 0);
	*(d - 1) = '/';
	*d = '\0';
	d = buf;
	s = buf;
	while (*s)
		if ((*d++ = *s++) == '/' && d > buf + 1) {
			register char  *t = d - 2;
			switch (*t) {
			case '/': 	/* found // in the name */
				--d;
				break;
			case '.': 
				switch (*--t) {
				case '/': /* found /./ in the name */
					d -= 2;
					break;
				case '.': 
					if (*--t == '/') {	/* found /../ */
						while (t > buf && *--t != '/');
						d = t + 1;
					}
					break;
				}
				break;
			}
		}
	if (*(d - 1) == '/' && d > buf+1)
		d--;
	*d = '\0';
	return buf;
}

/*
 * expansion de nom de fichiers:
 *
 *	?	  matche un caractere quelconque
 *	*	  matche une chaine quelconque (eventuellement vide)
 *	[x-yX-YZ] matche un caractere de x a y OU de X a Y ou Z
 *
 * retourne 1 si "s" matche "re" 0 sinon.
 */

int FilenameMatch (char* re, char* s)
{
	char*	cp;
	int		ok;

	for (;;) {
		switch (*re) {
			case '[':
				/* tester s'il ya un crochet fermant */
				for (cp = re; *cp != ']';)
					if (0 == *cp++)
						/* chercher un vrai crochet */
						goto def;
				/* ok a roule */
				for (re++, ok = 0; *re != ']';) {
					if (re [1] == '-') {
						if (*s >= *re && *s <= re [2]) {
							ok++;
							break;
						}
						re += 3;
					} else {
						if (*s == *re) {
							ok++;
							break;
						}
						re++;
					}
				}
				while (*re++ != ']');
				if (0 == ok)
					return 0;
				s++;
				continue;
	
			case 0:
				return *s == 0;
	
			case '?':
				if (0 == *s)
					return 0;
				re++;
				s++;
				continue;
	
			case '*':
				if (0 == re [1])
					return 1;
				re++;
				for (;;) {
					/* la chaine est termine: c'est rat! */
					if (*s == 0)
						return 0;
					if (FilenameMatch (re, s++))
						return 1;
				}
				/* not reached */
	
			default: def:
				if (*re++ != *s++)
					return 0;
				continue;
		}
	}
}
